#include <stdio.h>

int intlen(int i) {
  int l = 0;
  while (i > 0) { i /= 10; l++; }
  return l;
}

void print_int(int i, int n) {
  int l = intlen(i);
  int x = (n-l)/2;
  printf("%*s%d%*s", x, "", i, n-x-l, "");
}

int main(int argc, char **argv) {
  int n, c, r, min_width;
  int i, j, k;
  if (argc >= 2 && argc <= 4) {
    /* make an n x n board */
    n = atoi(argv[1]);
    if (n < 1) n = 1;

    /* cell width in columns */
    c = argc >= 3 ? atoi(argv[2]) : 2;
    min_width = intlen(n);
    if (c < min_width) c = min_width;

    /* cell height in rows */
    r = argc == 4 ? atoi(argv[3]) : (c+1)/2;
    if (r < 1) r = 1;
  } else {
    printf("usage: board (board_size) [cell_width] [cell_height]\n");
    return 1;
  }

  /* print column headers */
  printf("%*s", min_width+1, "");
  for (i = 0; i < n; i++)
    { print_int(i+1, c); printf(" "); }
  printf("\n");

  /* print cells */
  for (i = 0; i < n; i++) {
    for (j = 0; j < r; j++) {
      /* print row header */
      if (j+1 == (r+1)/2)
        print_int(i+1, min_width+1);
      else
        printf("%*s", min_width+1, "");
      /* print cells */
      for (k = 0; k < n-1; k++)
        { printf("%*s|", c, ""); }
      printf("\n");
    }
    /* print divider */
    if (i < n-1) {
      printf("%*s", min_width+1, "");
      for (j = 0; j < n; j++) {
        for (k = 0; k < c; k++) printf("-");
        if (j < n-1) printf("+");
      }
      printf("\n");
    }
  }

  return 0;
}

